# -*- coding: utf-8 -*-
import json, time, hashlib
try:
    from urllib2 import urlopen, Request
except ImportError:
    from urllib.request import urlopen, Request
try:
    from urlparse import urljoin, urlparse, parse_qs
except ImportError:
    from urllib.parse import urljoin, urlparse, parse_qs
try:
    from urllib import quote, unquote
except ImportError:
    from urllib.parse import quote, unquote
ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.85 Safari/537.36'


def getjson(url):
    request = Request(url, headers={'User-Agent': ua})
    return json.loads(urlopen(request).read().decode('utf-8'))


def urlalt(url):
    t = int(time.time() * 1000)
    o = urlparse(url)
    s = unquote(o.query).lower()
    privateKey = ['version001', 'vers1on001', 'vers1on00i', 'bersion001', 'vcrsion001', 'versi0n001', 'versio_001',
                  'version0o1']
    s = '%d&%s&%s' % (t, s, privateKey[t % len(privateKey)])
    try:
        md5 = hashlib.md5(s).hexdigest()
    except TypeError:
        md5 = hashlib.md5(s.encode('utf-8')).hexdigest()
    return '%s&vv=%s&pub=%d' % (url, md5, t)


def category(cat, page=1):
    url = 'https://m8.ifvod.tv/api/list/Search?cinema=1&page=%d&size=30&cid=%s' % (page, cat)
    url = urlalt(url)
    try:
        data = getjson(url)
    except Exception as e:
        return {'code': 'ifvod 100', 'error': str(e)}
    if data['data']['msg']:
        return {'code': 'ifvod 101', 'error': data['data']['msg']}
    ret = []
    for e in data['data']['info'][0]['result']:
        plot = []
        if 'lastName' in e and e['lastName']:
            plot.append(u'更新：%s' % e['lastName'])
        if 'rating' in e and e['rating']:
            plot.append(u'评分：%s' % e['rating'])
        if 'year' in e and e['year']:
            plot.append(u'年份：%d' % e['year'])
        if 'regional' in e and e['regional']:
            plot.append(u'地区：%s' % e['regional'])
        if 'lang' in e and e['lang']:
            plot.append(u'语言：%s' % e['lang'])
        if 'directed' in e and e['directed']:
            plot.append(u'导演：%s' % e['directed'])
        if 'starring' in e and e['starring']:
            plot.append(u'演员：%s' % e['starring'])
        if 'contxt' in e and e['contxt']:
            plot.append(u'简介：%s' % e['contxt'])
        plot = '\n'.join(plot)
        ret.append({'title': e['title'], 'url': 'https://train.ifvod.tv/detail?id=%s' % e['key'], 'img': urljoin(url, e['image']), 'plot': plot})
    total = data['data']['info'][0]['recordcount']
    total = (total + 29) // 30
    if page < total:
        ret.append({'title': 'Next Page (%d/%d)' % (page + 1, total), 'category': cat, 'page': page + 1})
    return ret


def search(s, page=1):
    url = 'https://m8.ifvod.tv/api/list/Search?cinema=1&page=%d&size=30&tags=%s' % (page, quote(s))
    url = urlalt(url)
    try:
        data = getjson(url)
    except Exception as e:
        return {'code': 'ifvod 400', 'error': str(e)}
    if data['data']['msg']:
        return {'code': 'ifvod 401', 'error': data['data']['msg']}
    ret = []
    for e in data['data']['info'][0]['result']:
        plot = []
        if 'lastName' in e and e['lastName']:
            plot.append(u'更新：%s' % e['lastName'])
        if 'rating' in e and e['rating']:
            plot.append(u'评分：%s' % e['rating'])
        if 'year' in e and e['year']:
            plot.append(u'年份：%d' % e['year'])
        if 'regional' in e and e['regional']:
            plot.append(u'地区：%s' % e['regional'])
        if 'lang' in e and e['lang']:
            plot.append(u'语言：%s' % e['lang'])
        if 'directed' in e and e['directed']:
            plot.append(u'导演：%s' % e['directed'])
        if 'starring' in e and e['starring']:
            plot.append(u'演员：%s' % e['starring'])
        if 'contxt' in e and e['contxt']:
            plot.append(u'简介：%s' % e['contxt'])
        plot = '\n'.join(plot)
        ret.append({'title': e['title'], 'url': 'https://train.ifvod.tv/detail?id=%s' % e['key'], 'img': urljoin(url, e['image']), 'plot': plot})
    total = data['data']['info'][0]['recordcount']
    total = (total + 29) // 30
    if page < total:
        ret.append({'title': 'Next Page (%d/%d)' % (page + 1, total), 'search': s, 'page': page + 1})
    return ret


def detail(url):
    o = urlparse(url)
    q = parse_qs(o.query)
    if 'id' not in q:
        return {'code': 'ifvod 200', 'error': url}
    url = 'https://m8.ifvod.tv/api/video/detail?cinema=1&device=1&v=1&id=%s' % q['id'][0]
    url = urlalt(url)
    try:
        data = getjson(url)
    except Exception as e:
        return {'code': 'ifvod 201', 'error': str(e)}
    if data['data']['msg']:
        return {'code': 'ifvod 202', 'error': data['data']['msg']}
    ret = []
    for e in data['data']['info'][0]['guestSeriesList']:
        ret.append({e['name']: 'https://train.ifvod.tv/play?id=%s' % e['key']})
    return ret


def play(url):
    o = urlparse(url)
    q = parse_qs(o.query)
    if 'id' not in q:
        return {'code': 'ifvod 300', 'error': url}
    url = 'https://m8.ifvod.tv/api/video/play?cinema=1&id=%s&device=1&usersign=1' % q['id'][0]
    url = urlalt(url)
    try:
        data = getjson(url)
    except Exception as e:
        return {'code': 'ifvod 301', 'error': str(e)}
    if data['data']['msg']:
        return {'code': 'ifvod 302', 'error': data['data']['msg']}
    title = data['data']['info'][0]['vl']['title'] + data['data']['info'][0]['title']
    for e in data['data']['info'][0]['flvPathList']:
        if not e['isHls']:
            continue
        url = e['result']
        return {'title': title, 'url': urlalt(url)}
    return {'code': 'ifvod 303'}
